function ControlsScript(that){
	this.scene.setRule("gravity", 0);
	this.scene.setRule("isSnowing", false);
	this.scene.setRule("world", "space");
	this.scene.setRule("canShoot", true);
	this.scene.setRule("useBounds", true);
	this.scene.setRule("wave", 0);
	
	this.desirY += 100;
	
	var localOffsetX = -55,
		localOffsetY = 0;
	
	this.animations.add(function(i){ localOffsetY = 35 + 35 * (1 - ease(i)); that.scale = 2 + ease(i) * 0.5; }, null, 0.4);
	
	var fontWhite = this.atlas.gui.font.white,
		charW = fontWhite[0][2] + 1,
		charH = fontWhite[0][3] + 1;
	
		
	// Create Player
	var player = new Wizard(this);
	this.scene.addObject(player);
	
	var wasMouseDown = false;
	
	var elements = {
		back: {
			text: "$ CLICK HERE TO RETURN $",
			font: fontWhite,
			scale: 0.4,
			opacity: 1,
			active: false
		},
		
		body: {
			text: "YOU CAN TRY THESE CONTROLS HERE\n\n- USE *WASD* TO MOVE\n- USE THE MOUSE TO LOOK AROUND\n- CLICK OR USE *X* TO CAST SPELLS\n- USE *Q* AND *E* TO SELECT A SPELL\n\nTHE THREE BOXES AT THE TOP ARE\nA SHIELD AND HEALTH DISPLAY. YOUR\nSHIELD IS A VERTICAL BLUE DISPLAY\nTHAT GRADUALLY REGENERATES.",
			font: fontWhite,
			scale: 0.4,
			opacity: 1
		},
		
		title: {
			text: "- CONTROLS -",
			font: fontWhite,
			size: textSize(this, "- CONTROLS -", fontWhite, 0.8),
			scale: 0.8,
			opacity: 0.5
		}
	};
	
	
	this.stateUpdate = function(){
		// Positions
		elements.title.offsetX = this.ratio.width/this.scale/2 - elements.title.size.width/2 + localOffsetX;
		elements.title.offsetY = 10 + localOffsetY;
		
		elements.body.size = textSize(this, elements.body.text, fontWhite, elements.body.scale);
		elements.body.offsetX = this.ratio.width/this.scale/2 - elements.body.size.width/2 + localOffsetX;
		elements.body.offsetY = 25 + localOffsetY;
		
		elements.back.size = textSize(this, elements.back.text, fontWhite, elements.back.scale);
		elements.back.offsetX = this.ratio.width/this.scale/2 - elements.back.size.width/2 + localOffsetX;
		elements.back.offsetY = 65 + localOffsetY;
		
		
		for(var i in elements){
			var element = elements[i];
			if(element.active !== undefined) element.active = touchingText(that, element);
		}
		
		if(!wasMouseDown && (that.input.mouse.down || that.input.keys[13] || that.input.keys[32])){
			if(elements.back.active || that.input.keys[13] || that.input.keys[32]){
				that.input.mouse.down = false;
				
				while(this.animations.animations[0]) this.animations.remove(this.animations.animations[0]);
				this.scene.removeAllParticles();
				this.scene.removeAllObjects();
				this.updateDelta = 1;
				MenuScript.call(this, this);
			}
			
			delete that.input.keys[13];
			delete that.input.keys[32];
		}
		
		wasMouseDown = that.input.mouse.down;
	};
	
	
	this.stateDraw = function(context, textures, atlas){
		var offsetX, offsetY, scale, text,
			rotChar = ("_\\|/")[Math.floor(this.loop.frame / 6) % 4],
			rotChar2 = ("_\\|/")[Math.floor(this.loop.frame / 8) % 4],
		
		offsetX = 0;
		offsetY = 40;
		scale = 1;
		
		// Draw the text elements
		for(var i in elements){
			var element = elements[i];
			
			context.globalAlpha = element.opacity;
			drawText(context, textures, atlas, element.font, element.text.split("$").join(element.active ? rotChar : " ").split("#").join(rotChar2), element.offsetX, element.offsetY + (element.active ? Math.sin(this.loop.frame/8) * 0.4 - 0.2 : 0), element.scale);
		}
		
		context.globalAlpha = 1;
		
		
		var map, offsetX, offsetY, scale, subScale, b;
		
		// Display the health monitor
		var spacing = 2;
		scale = 1/1.4;
		offsetX = this.ratio.width/this.scale/ 2,
		offsetY = 2;
		
		offsetX -= player.maxLife * atlas.gui.hp[0][3] * scale / 4 + ((player.maxLife/4) - 1) * spacing / 2;
		
		for(var i=0; i<player.maxLife/2; i++){
			a = player.shield / player.shieldMax;
			map = i >= player.life/2 ? atlas.gui.hp[2] : (i + 0.5  === player.life/2 ? atlas.gui.hp[1] : atlas.gui.hp[0]);
			context.drawImage(textures.gui, map[0], map[1], map[2], map[3], i * (map[2] * scale + spacing) + offsetX, offsetY, map[2] * scale, map[3] * scale);
			if(a > 0) context.drawImage(textures.gui, map[0], map[1] + map[3] * (1 - a) + 13, map[2], map[3] * a, i * (map[2] * scale + spacing) + offsetX, offsetY + map[3] * scale * (1 - a), map[2] * scale, map[3] * scale * a);
		}
		
		
		var thisSpell = player.spellIndex,
			prevSpell = mod(player.spellIndex - 1, player.spells.length),
			nextSpell = mod(player.spellIndex + 1, player.spells.length);
		
		
		scale = 1;
		subScale = 1/1.4;
		offsetX = 6;
		offsetY = 6;
		
		
		// Display the previous spell selection
		map = atlas.gui.spells[prevSpell];
		context.drawImage(textures.gui, map[0], map[1], map[2], map[3], offsetX - map[2] * subScale + 4 * scale, offsetY + map[3] * scale - 2 * scale, map[2] * subScale, map[3] * subScale);
		
		context.globalAlpha = 0.45;
		map = atlas.gui.spellShadow;
		context.drawImage(textures.gui, map[0], map[1], map[2], map[3], offsetX - map[2] * subScale + 4 * scale, offsetY + map[3] * scale - 2 * scale, map[2] * subScale, map[3] * subScale);
		context.globalAlpha = 1;
		
		
		// Display the current spell selection
		map = atlas.gui.spells[thisSpell];
		context.drawImage(textures.gui, map[0], map[1], map[2], map[3], offsetX, offsetY, map[2] * scale, map[3] * scale);
		
		
		// Display the cooldown timer
		if(a = player.spellCooldown / player.spellCooldownMax){
			map = atlas.gui.spellCooldown;
			context.drawImage(textures.gui, map[0], map[1] + (1 - a) * map[3], map[2], a * map[3], offsetX, offsetY + (1 - a) * map[3], map[2], a * map[3]);
		}
		
		
		// Display the next spell selection
		map = atlas.gui.spells[nextSpell];
		context.drawImage(textures.gui, map[0], map[1], map[2], map[3], offsetX + map[2] * scale - 2 * scale, offsetY - map[3] * subScale + 4 * scale, map[2] * subScale, map[3] * subScale);
		
		context.globalAlpha = 0.45;
		map = atlas.gui.spellShadow;
		context.drawImage(textures.gui, map[0], map[1], map[2], map[3], offsetX + map[2] * scale - 2 * scale, offsetY - map[3] * subScale + 4 * scale, map[2] * subScale, map[3] * subScale);
		context.globalAlpha = 1;
	};
}
